<template>
  <div></div>
</template>

<script>
// Vendor
import { tileLayer } from 'leaflet'

// Mixins
import ParentWorkspaceMixin from '@/dashboard/mixins/ParentWorkspace'

import { findParentComponentByName } from '@/core/util'


export default {
  name: 'leafletwmssimplelayer',

  mixins: [
    ParentWorkspaceMixin,
  ],

  props: {
    url: {
      type: String,
    },

    name: {
      type: String,
    },
  },


  computed: {
    leafletMap: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletmap')
      }
    },

    leafletPane: {
      get() {
        return findParentComponentByName(this.$parent, 'leafletpane')
      }
    },

    // The service URL for this layer
    serviceUrl: {
      get() {
        return this.url
      },
    },
  },

  methods: {
    create() {
      this.layerObject = tileLayer.wms(this.serviceUrl, this.getOptions())
      return this.add()
    },

    add() {
      this.layerObject.addTo(this.leafletMap.mapObject)
      return this
    },

    getOptions() {
      return {
        pane: this.leafletPane.name,
        layers: this.name,
        format: 'image/png',
        transparent: true,
        tileSize: 512,
      }
    },
  },

  mounted() {
    this.create()
  },
}
</script>
